<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/SymbolLookup/Scopes.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/SymbolLookup/Scopes.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/SymbolLookup/Scopes.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line">#ifndef Synopsis_SymbolLookup_Scopes_hh_</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#define Synopsis_SymbolLookup_Scopes_hh_</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line">#include &lt;Synopsis/SymbolLookup/Scope.hh&gt;</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line">#include &lt;string&gt;</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line">#include &lt;vector&gt;</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">#include &lt;list&gt;</span>
<a id="line14"></a><span class="lineno"> 14</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line16"></a><span class="lineno"> 16</span><span class="line">{</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/SymbolLookup.html" title="namespace Synopsis::SymbolLookup">SymbolLookup</a></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line">{</span>
<a id="line19"></a><span class="lineno"> 19</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">class TemplateParameterScope;</span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line">class LocalScope;</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">class PrototypeScope;</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">class FunctionScope;</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">class Class;</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">class Namespace;</span>
<a id="line26"></a><span class="lineno"> 26</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line"><span class="comment">//. A Visitor for Scopes.</span></span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line"><span class="comment">//. The default implementation does nothing, so</span></span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line"><span class="comment">//. users only need to implement the ones they need.</span></span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html" title="class Synopsis::SymbolLookup::ScopeVisitor">ScopeVisitor</a></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">{</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#_tScopeVisitor_l_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::~ScopeVisitor()">~ScopeVisitor</a>() {}</span>
<a id="line34"></a><span class="lineno"> 34</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lTemplateParameterScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(TemplateParameterScope*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">TemplateParameterScope</a> *) {}</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lLocalScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(LocalScope*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html" title="class Synopsis::SymbolLookup::LocalScope">LocalScope</a> *) {}</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lPrototypeScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(PrototypeScope*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html" title="class Synopsis::SymbolLookup::PrototypeScope">PrototypeScope</a> *) {}</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lFunctionScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(FunctionScope*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html" title="class Synopsis::SymbolLookup::FunctionScope">FunctionScope</a> *) {}</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lClass_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(Class*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Class.html" title="class Synopsis::SymbolLookup::Class">Class</a> *) {}</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lNamespace_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(Namespace*)">visit</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html" title="class Synopsis::SymbolLookup::Namespace">Namespace</a> *) {}</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">};</span>
<a id="line42"></a><span class="lineno"> 42</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">TemplateParameterScope</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a></span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">{</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::TemplateParameterScope::TemplateParameterScope(const PTree::List*,const Scope*)">TemplateParameterScope</a>(<a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">PTree::List const</a> *node, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *outer)</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">    : my_node(node), my_outer(outer-&gt;ref()) {}</span>
<a id="line48"></a><span class="lineno"> 48</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a></span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::TemplateParameterScope::unqualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext)const">unqualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>) const;</span>
<a id="line51"></a><span class="lineno"> 51</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html#outer_scope_l_rconst" title="member function Synopsis::SymbolLookup::TemplateParameterScope::outer_scope()const">outer_scope</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html#my_outer" title="data member Synopsis::SymbolLookup::TemplateParameterScope::my_outer">my_outer</a>;}</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html#accept_lScopeVisitor_S_r" title="member function Synopsis::SymbolLookup::TemplateParameterScope::accept(ScopeVisitor*)">accept</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html" title="class Synopsis::SymbolLookup::ScopeVisitor">ScopeVisitor</a> *v) { <a href="" title="parameter v">v</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lTemplateParameterScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(TemplateParameterScope*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line54"></a><span class="lineno"> 54</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line"><span class="keyword">protected</span>:</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html#_tTemplateParameterScope_l_r" title="member function Synopsis::SymbolLookup::TemplateParameterScope::~TemplateParameterScope()">~TemplateParameterScope</a>() { <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html#my_outer" title="data member Synopsis::SymbolLookup::TemplateParameterScope::my_outer">my_outer</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#unref_l_rconst" title="member function Synopsis::SymbolLookup::Scope::unref()const">unref</a>();}</span>
<a id="line57"></a><span class="lineno"> 57</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">PTree::List const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html#my_node" title="data member Synopsis::SymbolLookup::TemplateParameterScope::my_node">my_node</a>;</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope       const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html#my_outer" title="data member Synopsis::SymbolLookup::TemplateParameterScope::my_outer">my_outer</a>;</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">};</span>
<a id="line62"></a><span class="lineno"> 62</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html" title="class Synopsis::SymbolLookup::LocalScope">LocalScope</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a></span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">{</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::LocalScope::LocalScope(const PTree::List*,const Scope*)">LocalScope</a>(<a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">PTree::List const</a> *node, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *outer)</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">    : my_node(node), my_outer(outer-&gt;ref()) {}</span>
<a id="line68"></a><span class="lineno"> 68</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html#outer_scope_l_rconst" title="member function Synopsis::SymbolLookup::LocalScope::outer_scope()const">outer_scope</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html#my_outer" title="data member Synopsis::SymbolLookup::LocalScope::my_outer">my_outer</a>;}</span>
<a id="line70"></a><span class="lineno"> 70</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> </span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::LocalScope::unqualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext)const">unqualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>) const;</span>
<a id="line73"></a><span class="lineno"> 73</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html#accept_lScopeVisitor_S_r" title="member function Synopsis::SymbolLookup::LocalScope::accept(ScopeVisitor*)">accept</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html" title="class Synopsis::SymbolLookup::ScopeVisitor">ScopeVisitor</a> *v) { <a href="" title="parameter v">v</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lTemplateParameterScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(TemplateParameterScope*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line75"></a><span class="lineno"> 75</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line"><span class="keyword">protected</span>:</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html#_tLocalScope_l_r" title="member function Synopsis::SymbolLookup::LocalScope::~LocalScope()">~LocalScope</a>() { <a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html#my_outer" title="data member Synopsis::SymbolLookup::LocalScope::my_outer">my_outer</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#unref_l_rconst" title="member function Synopsis::SymbolLookup::Scope::unref()const">unref</a>();}</span>
<a id="line78"></a><span class="lineno"> 78</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">PTree::List const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html#my_node" title="data member Synopsis::SymbolLookup::LocalScope::my_node">my_node</a>;</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope       const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/LocalScope.html#my_outer" title="data member Synopsis::SymbolLookup::LocalScope::my_outer">my_outer</a>;</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">};</span>
<a id="line83"></a><span class="lineno"> 83</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html" title="class Synopsis::SymbolLookup::FunctionScope">FunctionScope</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a></span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">{</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::FunctionScope::FunctionScope(const PTree::Declaration*,PrototypeScope*,const Scope*)">FunctionScope</a>(<a href="../../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration const</a> *, <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html" title="class Synopsis::SymbolLookup::PrototypeScope">PrototypeScope</a> *, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *);</span>
<a id="line88"></a><span class="lineno"> 88</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::FunctionScope::use(const PTree::UsingDirective*)">use</a>(<a href="../../../Scopes/Synopsis/PTree/UsingDirective.html" title="class Synopsis::PTree::UsingDirective">PTree::UsingDirective const</a> *);</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#outer_scope_l_rconst" title="member function Synopsis::SymbolLookup::FunctionScope::outer_scope()const">outer_scope</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#my_outer" title="data member Synopsis::SymbolLookup::FunctionScope::my_outer">my_outer</a>;}</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> </span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::FunctionScope::unqualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext)const">unqualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>) const;</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> </span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::FunctionScope::qualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext)const">qualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>) const;</span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">  <span class="comment">// FIXME: what is 'name' ? (template parameters...)</span></span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">  <a href="" title="typedef std::string">std::string</a> <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#name_l_rconst" title="member function Synopsis::SymbolLookup::FunctionScope::name()const">name</a>() const;</span>
<a id="line98"></a><span class="lineno"> 98</span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#accept_lScopeVisitor_S_r" title="member function Synopsis::SymbolLookup::FunctionScope::accept(ScopeVisitor*)">accept</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html" title="class Synopsis::SymbolLookup::ScopeVisitor">ScopeVisitor</a> *v) { <a href="" title="parameter v">v</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lTemplateParameterScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(TemplateParameterScope*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line100"></a><span class="lineno">100</span>
<a id="line101"></a><span class="lineno">101</span><span class="line"><span class="keyword">protected</span>:</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#_tFunctionScope_l_r" title="member function Synopsis::SymbolLookup::FunctionScope::~FunctionScope()">~FunctionScope</a>() { <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#my_outer" title="data member Synopsis::SymbolLookup::FunctionScope::my_outer">my_outer</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#unref_l_rconst" title="member function Synopsis::SymbolLookup::Scope::unref()const">unref</a>();}</span>
<a id="line103"></a><span class="lineno">103</span>
<a id="line104"></a><span class="lineno">104</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::set">set</a>&lt;<a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html" title="class Synopsis::SymbolLookup::Namespace">Namespace const</a> *&gt; <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#Using" title="typedef Synopsis::SymbolLookup::FunctionScope::Using">Using</a>;</span>
<a id="line106"></a><span class="lineno">106</span>
<a id="line107"></a><span class="lineno">107</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">PTree::Declaration const</a> *    <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#my_decl" title="data member Synopsis::SymbolLookup::FunctionScope::my_decl">my_decl</a>;</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *                 <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#my_outer" title="data member Synopsis::SymbolLookup::FunctionScope::my_outer">my_outer</a>;</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html" title="class Synopsis::SymbolLookup::Class">Class const</a> *                 <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#my_class" title="data member Synopsis::SymbolLookup::FunctionScope::my_class">my_class</a>;</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">TemplateParameterScope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#my_parameters" title="data member Synopsis::SymbolLookup::FunctionScope::my_parameters">my_parameters</a>;</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#Using" title="typedef Synopsis::SymbolLookup::FunctionScope::Using">Using</a>                         <a href="../../../Scopes/Synopsis/SymbolLookup/FunctionScope.html#my_using" title="data member Synopsis::SymbolLookup::FunctionScope::my_using">my_using</a>;</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">};</span>
<a id="line113"></a><span class="lineno">113</span>
<a id="line114"></a><span class="lineno">114</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html" title="class Synopsis::SymbolLookup::PrototypeScope">PrototypeScope</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a></span>
<a id="line115"></a><span class="lineno">115</span><span class="line">{</span>
<a id="line116"></a><span class="lineno">116</span><span class="line">  friend class FunctionScope;</span>
<a id="line117"></a><span class="lineno">117</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::PrototypeScope::PrototypeScope(const PTree::Node*,const Scope*,const TemplateParameterScope*)">PrototypeScope</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *decl, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *outer,</span>
<a id="line119"></a><span class="lineno">119</span><span class="line">		 <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">TemplateParameterScope const</a> *params)</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">    : my_decl(decl), my_outer(outer-&gt;ref()), my_parameters(params) {}</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#outer_scope_l_rconst" title="member function Synopsis::SymbolLookup::PrototypeScope::outer_scope()const">outer_scope</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#my_outer" title="data member Synopsis::SymbolLookup::PrototypeScope::my_outer">my_outer</a>;}</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> </span>
<a id="line124"></a><span class="lineno">124</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::PrototypeScope::unqualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext)const">unqualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>) const;</span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#declaration_l_rconst" title="member function Synopsis::SymbolLookup::PrototypeScope::declaration()const">declaration</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#my_decl" title="data member Synopsis::SymbolLookup::PrototypeScope::my_decl">my_decl</a>;}</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">TemplateParameterScope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#parameters_l_rconst" title="member function Synopsis::SymbolLookup::PrototypeScope::parameters()const">parameters</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#my_parameters" title="data member Synopsis::SymbolLookup::PrototypeScope::my_parameters">my_parameters</a>;}</span>
<a id="line128"></a><span class="lineno">128</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">  <a href="" title="typedef std::string">std::string</a> <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#name_l_rconst" title="member function Synopsis::SymbolLookup::PrototypeScope::name()const">name</a>() const;</span>
<a id="line130"></a><span class="lineno">130</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#accept_lScopeVisitor_S_r" title="member function Synopsis::SymbolLookup::PrototypeScope::accept(ScopeVisitor*)">accept</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html" title="class Synopsis::SymbolLookup::ScopeVisitor">ScopeVisitor</a> *v) { <a href="" title="parameter v">v</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lTemplateParameterScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(TemplateParameterScope*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line132"></a><span class="lineno">132</span>
<a id="line133"></a><span class="lineno">133</span><span class="line"><span class="keyword">protected</span>:</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#_tPrototypeScope_l_r" title="member function Synopsis::SymbolLookup::PrototypeScope::~PrototypeScope()">~PrototypeScope</a>() { <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#my_outer" title="data member Synopsis::SymbolLookup::PrototypeScope::my_outer">my_outer</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#unref_l_rconst" title="member function Synopsis::SymbolLookup::Scope::unref()const">unref</a>();}</span>
<a id="line135"></a><span class="lineno">135</span>
<a id="line136"></a><span class="lineno">136</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">PTree::Node const</a> *           <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#my_decl" title="data member Synopsis::SymbolLookup::PrototypeScope::my_decl">my_decl</a>;</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *                 <a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#my_outer" title="data member Synopsis::SymbolLookup::PrototypeScope::my_outer">my_outer</a>;</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">TemplateParameterScope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/PrototypeScope.html#my_parameters" title="data member Synopsis::SymbolLookup::PrototypeScope::my_parameters">my_parameters</a>;</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">};</span>
<a id="line141"></a><span class="lineno">141</span>
<a id="line142"></a><span class="lineno">142</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html" title="class Synopsis::SymbolLookup::Class">Class</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a></span>
<a id="line143"></a><span class="lineno">143</span><span class="line">{</span>
<a id="line144"></a><span class="lineno">144</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::vector">vector</a>&lt;<a href="../../../Scopes/Synopsis/SymbolLookup/Class.html" title="class Synopsis::SymbolLookup::Class">Class const</a> *&gt; <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#Bases" title="typedef Synopsis::SymbolLookup::Class::Bases">Bases</a>;</span>
<a id="line146"></a><span class="lineno">146</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::Class::Class(const PTree::ClassSpec*,const Scope*,const Bases&amp;,const TemplateParameterScope*)">Class</a>(<a href="../../../Scopes/Synopsis/PTree/ClassSpec.html" title="class Synopsis::PTree::ClassSpec">PTree::ClassSpec const</a> *spec, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *outer,</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">	<a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#Bases" title="typedef Synopsis::SymbolLookup::Class::Bases">Bases const</a> &amp;bases, <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">TemplateParameterScope const</a> *params)</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">    : my_spec(spec), my_outer(outer-&gt;ref()), my_bases(bases), my_parameters(params)</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">  {</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">  }</span>
<a id="line152"></a><span class="lineno">152</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#outer_scope_l_rconst" title="member function Synopsis::SymbolLookup::Class::outer_scope()const">outer_scope</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#my_outer" title="data member Synopsis::SymbolLookup::Class::my_outer">my_outer</a>;}</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> </span>
<a id="line155"></a><span class="lineno">155</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::Class::unqualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext)const">unqualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>) const;</span>
<a id="line156"></a><span class="lineno">156</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">  <span class="comment">// FIXME: what is 'name' ? (template parameters...)</span></span>
<a id="line158"></a><span class="lineno">158</span><span class="line">  <a href="" title="typedef std::string">std::string</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#name_l_rconst" title="member function Synopsis::SymbolLookup::Class::name()const">name</a>() const;</span>
<a id="line159"></a><span class="lineno">159</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#accept_lScopeVisitor_S_r" title="member function Synopsis::SymbolLookup::Class::accept(ScopeVisitor*)">accept</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html" title="class Synopsis::SymbolLookup::ScopeVisitor">ScopeVisitor</a> *v) { <a href="" title="parameter v">v</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lTemplateParameterScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(TemplateParameterScope*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line161"></a><span class="lineno">161</span>
<a id="line162"></a><span class="lineno">162</span><span class="line"><span class="keyword">protected</span>:</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#_tClass_l_r" title="member function Synopsis::SymbolLookup::Class::~Class()">~Class</a>() { <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#my_outer" title="data member Synopsis::SymbolLookup::Class::my_outer">my_outer</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#unref_l_rconst" title="member function Synopsis::SymbolLookup::Scope::unref()const">unref</a>();}</span>
<a id="line164"></a><span class="lineno">164</span>
<a id="line165"></a><span class="lineno">165</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/ClassSpec.html" title="class Synopsis::PTree::ClassSpec">PTree::ClassSpec       const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#my_spec" title="data member Synopsis::SymbolLookup::Class::my_spec">my_spec</a>;</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope                  const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#my_outer" title="data member Synopsis::SymbolLookup::Class::my_outer">my_outer</a>;</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#Bases" title="typedef Synopsis::SymbolLookup::Class::Bases">Bases</a>                         <a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#my_bases" title="data member Synopsis::SymbolLookup::Class::my_bases">my_bases</a>;</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/TemplateParameterScope.html" title="class Synopsis::SymbolLookup::TemplateParameterScope">TemplateParameterScope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Class.html#my_parameters" title="data member Synopsis::SymbolLookup::Class::my_parameters">my_parameters</a>;</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">};</span>
<a id="line171"></a><span class="lineno">171</span>
<a id="line172"></a><span class="lineno">172</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html" title="class Synopsis::SymbolLookup::Namespace">Namespace</a> : <span class="keyword">public</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope</a></span>
<a id="line173"></a><span class="lineno">173</span><span class="line">{</span>
<a id="line174"></a><span class="lineno">174</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::Namespace::Namespace(const PTree::NamespaceSpec*,const Namespace*)">Namespace</a>(<a href="../../../Scopes/Synopsis/PTree/NamespaceSpec.html" title="class Synopsis::PTree::NamespaceSpec">PTree::NamespaceSpec const</a> *spec, <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html" title="class Synopsis::SymbolLookup::Namespace">Namespace const</a> *outer)</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">    : my_spec(spec),</span>
<a id="line177"></a><span class="lineno">177</span><span class="line">      my_outer(outer ? static_cast&lt;Namespace const *&gt;(outer-&gt;ref()) : 0)</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">  {</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">  }</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">  <span class="comment">//. Find a nested namespace.</span></span>
<a id="line181"></a><span class="lineno">181</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html" title="class Synopsis::SymbolLookup::Namespace">Namespace</a> *<a href="" title="member function Synopsis::SymbolLookup::Namespace::find_namespace(const PTree::NamespaceSpec*)const">find_namespace</a>(<a href="../../../Scopes/Synopsis/PTree/NamespaceSpec.html" title="class Synopsis::PTree::NamespaceSpec">PTree::NamespaceSpec const</a> *name) const;</span>
<a id="line182"></a><span class="lineno">182</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::SymbolLookup::Namespace::use(const PTree::UsingDirective*)">use</a>(<a href="../../../Scopes/Synopsis/PTree/UsingDirective.html" title="class Synopsis::PTree::UsingDirective">PTree::UsingDirective const</a> *);</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html" title="class Synopsis::SymbolLookup::Scope">Scope const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#outer_scope_l_rconst" title="member function Synopsis::SymbolLookup::Namespace::outer_scope()const">outer_scope</a>() const { <span class="keyword">return</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#my_outer" title="data member Synopsis::SymbolLookup::Namespace::my_outer">my_outer</a>;}</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> </span>
<a id="line186"></a><span class="lineno">186</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::Namespace::unqualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext)const">unqualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>) const;</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> </span>
<a id="line188"></a><span class="lineno">188</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::Namespace::qualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext)const">qualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>) const;</span>
<a id="line189"></a><span class="lineno">189</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">  <span class="comment">// FIXME: should that really be a string ? It may be better to be conform with</span></span>
<a id="line191"></a><span class="lineno">191</span><span class="line"><span class="comment">  // Class::name, which, if the class is a template, can't be a string (or can it ?)</span></span>
<a id="line192"></a><span class="lineno">192</span><span class="line">  <a href="" title="typedef std::string">std::string</a> <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#name_l_rconst" title="member function Synopsis::SymbolLookup::Namespace::name()const">name</a>() const;</span>
<a id="line193"></a><span class="lineno">193</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#accept_lScopeVisitor_S_r" title="member function Synopsis::SymbolLookup::Namespace::accept(ScopeVisitor*)">accept</a>(<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html" title="class Synopsis::SymbolLookup::ScopeVisitor">ScopeVisitor</a> *v) { <a href="" title="parameter v">v</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/ScopeVisitor.html#visit_lTemplateParameterScope_S_r" title="member function Synopsis::SymbolLookup::ScopeVisitor::visit(TemplateParameterScope*)">visit</a>(<span class="keyword">this</span>);}</span>
<a id="line195"></a><span class="lineno">195</span>
<a id="line196"></a><span class="lineno">196</span><span class="line"><span class="keyword">protected</span>:</span>
<a id="line197"></a><span class="lineno">197</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#_tNamespace_l_r" title="member function Synopsis::SymbolLookup::Namespace::~Namespace()">~Namespace</a>() { <span class="keyword">if</span> (<a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#my_outer" title="data member Synopsis::SymbolLookup::Namespace::my_outer">my_outer</a>) <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#my_outer" title="data member Synopsis::SymbolLookup::Namespace::my_outer">my_outer</a>-&gt;<a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#unref_l_rconst" title="member function Synopsis::SymbolLookup::Scope::unref()const">unref</a>();}</span>
<a id="line198"></a><span class="lineno">198</span>
<a id="line199"></a><span class="lineno">199</span><span class="line"><span class="keyword">private</span>:</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">  <span class="keyword">typedef</span> std::<a href="" title="class std::set">set</a>&lt;<a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html" title="class Synopsis::SymbolLookup::Namespace">Namespace const</a> *&gt; <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#Using" title="typedef Synopsis::SymbolLookup::Namespace::Using">Using</a>;</span>
<a id="line201"></a><span class="lineno">201</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> </span>
<a id="line203"></a><span class="lineno">203</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::Namespace::unqualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext,Using&amp;)const">unqualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>, <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#Using" title="typedef Synopsis::SymbolLookup::Namespace::Using">Using</a> &amp;) const;</span>
<a id="line204"></a><span class="lineno">204</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup.html#SymbolSet" title="typedef Synopsis::SymbolLookup::SymbolSet">SymbolSet</a> </span>
<a id="line205"></a><span class="lineno">205</span><span class="line">  <a href="" title="member function Synopsis::SymbolLookup::Namespace::qualified_lookup(const PTree::Encoding&amp;,Scope::LookupContext,Using&amp;)const">qualified_lookup</a>(<a href="../../../Scopes/Synopsis/PTree/Encoding.html" title="class Synopsis::PTree::Encoding">PTree::Encoding const</a> &amp;, <a href="../../../Scopes/Synopsis/SymbolLookup/Scope.html#LookupContext" title="typedef Synopsis::SymbolLookup::Scope::LookupContext">LookupContext</a>, <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#Using" title="typedef Synopsis::SymbolLookup::Namespace::Using">Using</a> &amp;) const;</span>
<a id="line206"></a><span class="lineno">206</span>
<a id="line207"></a><span class="lineno">207</span><span class="line">  <a href="../../../Scopes/Synopsis/PTree/NamespaceSpec.html" title="class Synopsis::PTree::NamespaceSpec">PTree::NamespaceSpec const</a> *<a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#my_spec" title="data member Synopsis::SymbolLookup::Namespace::my_spec">my_spec</a>;</span>
<a id="line208"></a><span class="lineno">208</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html" title="class Synopsis::SymbolLookup::Namespace">Namespace const</a> *           <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#my_outer" title="data member Synopsis::SymbolLookup::Namespace::my_outer">my_outer</a>;</span>
<a id="line209"></a><span class="lineno">209</span><span class="line">  <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#Using" title="typedef Synopsis::SymbolLookup::Namespace::Using">Using</a>                       <a href="../../../Scopes/Synopsis/SymbolLookup/Namespace.html#my_using" title="data member Synopsis::SymbolLookup::Namespace::my_using">my_using</a>;</span>
<a id="line210"></a><span class="lineno">210</span><span class="line">};</span>
<a id="line211"></a><span class="lineno">211</span>
<a id="line212"></a><span class="lineno">212</span><span class="line">}</span>
<a id="line213"></a><span class="lineno">213</span><span class="line">}</span>
<a id="line214"></a><span class="lineno">214</span>
<a id="line215"></a><span class="lineno">215</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:04 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
